Index: platform/ixus950_sd850/sub/100c/stubs_entry_2.S
===================================================================
--- platform/ixus950_sd850/sub/100c/stubs_entry_2.S	(Revision 727)
+++ platform/ixus950_sd850/sub/100c/stubs_entry_2.S	(Arbeitskopie)
@@ -57,8 +57,13 @@
 NHSTUB(GetOpticalTemperature, 0xFFA3D3E0)
 NHSTUB(PT_PlaySound, 0xFFB1A0A4)
 NHSTUB(taskNameToId, 0xFF935A64)
-
+// those are mainly to play around with them for me and to figure out how time
+// related functions work on my cam
+NHSTUB(getenv,0xFF9263C0)
+NHSTUB(putenv,0xFF92641C)
+NSTUB(localtime_r, 0xff924788)
 //NHSTUB(EnterToCompensationEVF, 0xFFFFFFFF) // Stub not found. When found, remove dummy function from lib.c.
 //NHSTUB(ExitFromCompensationEVF, 0xFFFFFFFF) // Stub not found. When found, remove dummy function from lib.c.
 NHSTUB(DoAFLock, 0xffb09200)
 NHSTUB(UnlockAF, 0xffb09280)
+NHSTUB(ExpTimeInMicroseconds,0xFF93CE88);
Index: platform/ixus950_sd850/sub/100c/stubs_auto.S
===================================================================
--- platform/ixus950_sd850/sub/100c/stubs_auto.S	(Revision 727)
+++ platform/ixus950_sd850/sub/100c/stubs_auto.S	(Arbeitskopie)
@@ -35,6 +35,54 @@
 STUB(FF932E10)
 STUB(FF935BD0)
 STUB(FF939F8C)
+STUB(FF93BD38)
+STUB(FF93C0BC)
+STUB(FF93CE88)
+STUB(FF93DFEC)
+STUB(FF93E0AC)
+STUB(FF93E42C)
+STUB(FF93F1F4)
+STUB(FF9605D0)
+STUB(FF9722A8)
+STUB(FF9723DC)
+STUB(FF972544)
+STUB(FF9725E0)
+STUB(FF97267C)
+STUB(FF972718)
+STUB(FF9727B4)
+STUB(FF9727F4)
+STUB(FF972804)
+STUB(FF9728C0)
+STUB(FF972A5C)
+STUB(FF972BA8)
+STUB(FF972C08)
+STUB(FF972EAC)
+STUB(FF973120)
+STUB(FF97341C)
+STUB(FF973684)
+STUB(FF973980)
+STUB(FF973AE0)
+STUB(FF973DDC)
+STUB(FF973F04)
+STUB(FF973FC8)
+STUB(FF974080)
+STUB(FF974130)
+STUB(FF97430C)
+STUB(FF97462C)
+STUB(FF974778)
+STUB(FF974A24)
+STUB(FF974BE0)
+STUB(FF974DC8)
+STUB(FF974F0C)
+STUB(FF9751D8)
+STUB(FF9752C8)
+STUB(FF976578)
+STUB(FF9768DC)
+STUB(FF976948)
+STUB(FF9769A4)
+STUB(FF976A00)
+STUB(FF9C2BB0)
+STUB(FF9DE41C)
 STUB(FFA4226C)
 STUB(FFA42780)
 STUB(FFA71658)
@@ -51,6 +99,7 @@
 STUB(FFAA20C8)
 STUB(FFAA2294)
 STUB(FFAB5944)
+STUB(FFAE28F8)
 STUB(FFAF185C)
 STUB(FFAF1CA4)
 STUB(FFB01550)
@@ -92,6 +141,7 @@
 STUB(FFB11440)
 STUB(FFB115D4)
 STUB(FFB17EE8)
+STUB(FFB21C80)
 STUB(FFB21C90)
 STUB(FFB21E2C)
 STUB(FFB223A8)
Index: platform/ixus950_sd850/sub/100c/makefile.inc.new
===================================================================
--- platform/ixus950_sd850/sub/100c/makefile.inc.new	(Revision 0)
+++ platform/ixus950_sd850/sub/100c/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/ixus950_sd850/shooting.c
===================================================================
--- platform/ixus950_sd850/shooting.c	(Revision 727)
+++ platform/ixus950_sd850/shooting.c	(Arbeitskopie)
@@ -118,7 +118,7 @@
 char* shooting_get_tv_str()
 {
     short int tvv;
-    long i;
+    unsigned i;
 //    _GetPropertyCase(69, &tvv, sizeof(tvv));
 //    _GetPropertyCase(262, &tvv, sizeof(tvv));
     _GetPropertyCase(PROPCASE_TV, &tvv, sizeof(tvv));	// 262 for DiGiC III
@@ -132,7 +132,7 @@
 char* shooting_get_av_str()
 {
     short int avv;
-    long i;
+    unsigned i;
 //    _GetPropertyCase(68, &avv, sizeof(avv));
 //    _GetPropertyCase(23, &avv, sizeof(avv));
     _GetPropertyCase(PROPCASE_AV, &avv, sizeof(avv));	// 23 for DiGiC III
@@ -146,7 +146,7 @@
 char* shooting_get_iso_str()
 {
     short int isov;
-    long i;
+    unsigned i;
     _GetPropertyCase(PROPCASE_ISO_MODE, &isov, sizeof(isov));
     for (i=0;i<ISO_SIZE;i++){
    if (iso_table[i].prop_id == isov)
Index: platform/ixus950_sd850/makefile.inc.new
===================================================================
--- platform/ixus950_sd850/makefile.inc.new	(Revision 0)
+++ platform/ixus950_sd850/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a630/sub/100c/makefile.inc.new
===================================================================
--- platform/a630/sub/100c/makefile.inc.new	(Revision 0)
+++ platform/a630/sub/100c/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a630/makefile.inc.new
===================================================================
--- platform/a630/makefile.inc.new	(Revision 0)
+++ platform/a630/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/makefile_generic.inc.new
===================================================================
--- platform/makefile_generic.inc.new	(Revision 0)
+++ platform/makefile_generic.inc.new	(Revision 0)
@@ -0,0 +1,25 @@
+
+
+LOCAL_CFLAGS:=-DLOW_LEVEL
+
+SUBDIRS=sub
+
+C_OBJS := main.o lib.o wrappers.o kbd.o shooting.o $(EXTRA_C_OBJS)
+ASM_OBJS := $(EXTRA_ASM_OBJS)
+OBJS := $(C_OBJS) $(ASM_OBJS)
+
+# stubs_init.o
+OBJS := $(call subdirize,$(OBJS) )
+C_OBJS := $(call subdirize,$(C_OBJS) )
+ASM_OBJS := $(call subdirize,$(ASM_OBJS) )
+
+$(eval $(call compile-targets, $(C_OBJS), $(LOCAL_CFLAGS) ) )
+$(eval $(call compile-asm-targets, $(ASM_OBJS), $(LOCAL_CFLAGS) ) )
+
+$(eval $(call ar-targets, libplatform.a, $(OBJS), ))
+
+$(eval $(call gen-rule, $(PLATFORM)-platform-clean,, rm -f $(OBJS) $(subdir)/*.$(DEPSUFFIX) $(subdir)/sub/$(PLATFORMSUB)/*.$(DEPSUFFIX) $(subdir)/libplatform.a ))
+
+$(PLATFORM)-platform-distclean: $(PLATFORM)-platform-clean
+
+# vim: ft=make
Index: platform/a550/sub/100c/makefile.inc.new
===================================================================
--- platform/a550/sub/100c/makefile.inc.new	(Revision 0)
+++ platform/a550/sub/100c/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o mount.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c mount.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a550/makefile.inc.new
===================================================================
--- platform/a550/makefile.inc.new	(Revision 0)
+++ platform/a550/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a650/sub/100d/makefile.inc.new
===================================================================
--- platform/a650/sub/100d/makefile.inc.new	(Revision 0)
+++ platform/a650/sub/100d/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a650/makefile.inc.new
===================================================================
--- platform/a650/makefile.inc.new	(Revision 0)
+++ platform/a650/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/generic/wrappers.c
===================================================================
--- platform/generic/wrappers.c	(Revision 727)
+++ platform/generic/wrappers.c	(Arbeitskopie)
@@ -2,6 +2,7 @@
 #include "lolevel.h"
 #include "platform.h"
 #include "conf.h"
+#include "math.h"
 
 #if CAM_DRYOS
 #define _U	0x01	/* upper */
@@ -792,6 +793,63 @@
  return 0;
 }
 
+void reverse_bytes_order_target(char* start, int count, char* dest) {
+// note, we will go to count rounded up to the nearest 32
+asm volatile(
+	"ldr	r3, =0xFF00FF\n"	// r3 = mask
+	"add	r1, r0, r1\n"		// r1 = start + count
+"LOOPB:\n"
+	"ldm	r0, {R4-R11}\n"		// load 8 words
+	
+	// out = ((in>>8) & 0xFF00FF) | ((in&0xFF00FF) << 8);
+	"mov	r12, r4, lsr #8\n"	// r12 = in >> 8
+	"and	r12, r12, r3\n"		// r12 &= 0xFF00FF
+	"and	r4, r4, r3\n"		// r4 = in & 0xFF00FF
+	"orr	r4, r12, r4, asl #8\n" // out = r12 | (r4 << 8)
+
+	"mov	r12, r5, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r5, r5, r3\n"
+	"orr	r5, r12, r5, asl #8\n"
+
+	"mov	r12, r6, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r6, r6, r3\n"
+	"orr	r6, r12, r6, asl #8\n"
+
+	"mov	r12, r7, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r7, r7, r3\n"
+	"orr	r7, r12, r7, asl #8\n"
+
+	"mov	r12, r8, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r8, r8, r3\n"
+	"orr	r8, r12, r8, asl #8\n"
+
+	"mov	r12, r9, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r9, r9, r3\n"
+	"orr	r9, r12, r9, asl #8\n"
+
+	"mov	r12, r10, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r10, r10, r3\n"
+	"orr	r10, r12, r10, asl #8\n"
+
+	"mov	r12, r11, lsr #8\n"
+	"and	r12, r12, r3\n"
+	"and	r11, r11, r3\n"
+	"orr	r11, r12, r11, asl #8\n"
+
+	"stmia	r2!, {r4-r11}\n"	// store and increment
+
+	"cmp	r0, r1\n"
+	"bcc	LOOPB\n"
+	".pool\n"
+	:::"r0","r1","r2","r3","r4","r5","r6","r7","r8","r9","r10","r11","r12"
+ );
+}
 void reverse_bytes_order(char* start, int count){
 // note, we will go to count rounded up to the nearest 32
 asm volatile(
@@ -923,3 +981,14 @@
  _iosDevDelete(drv_struct);
 #endif
 }
+
+#if defined(CAM_HAS_EXTENDED_TV_LENGTH) && (CAM_HAS_EXTENDED_TV_LENGTH == 1)
+int  ExpTimeInMicroseconds(int apex_tv){
+ if (apex_tv<-576)
+ {
+     // for my ixus950is it is very important that this is pow() and not __pow() !
+     return 1000000.0*pow(2.0, -apex_tv/96.0);
+ }
+ else return _ExpTimeInMicroseconds(apex_tv);
+}
+#endif
Index: platform/generic/main.c
===================================================================
--- platform/generic/main.c	(Revision 727)
+++ platform/generic/main.c	(Arbeitskopie)
@@ -119,6 +119,12 @@
 	  #endif
 	}
 
+#if defined(CAM_HAS_EXTENDED_TV_LENGTH) && (CAM_HAS_EXTENDED_TV_LENGTH == 1)
+	if (my_ncmp(name, "tExpDrvTas",10) == 0){
+	    *entry = (long)_task_ExpDrvTask;
+	}
+#endif
+
 	core_hook_task_create(pNewTcb);
     }
 }
Index: platform/generic/shooting.c
===================================================================
--- platform/generic/shooting.c	(Revision 727)
+++ platform/generic/shooting.c	(Arbeitskopie)
@@ -37,7 +37,19 @@
 static const short koef[] = {0, 1,10,100,1000};
 static const float shutter_koef[] = {0, 0.00001, 0.0001,0.001,0.01,0.1,1,10,100,1000};
 static const char * expo_shift[] = { "Off", "1/3Ev","2/3Ev", "1Ev", "1 1/3Ev", "1 2/3Ev", "2Ev", "2 1/3Ev", "2 2/3Ev", "3Ev", "3 1/3Ev", "3 2/3Ev", "4Ev"};
-static const char* tv_override[]={"64","50.8", "40.3", "32", "25.4","20","16", "12.7", "10","8", "6.3","5","4","3.2", "2.5","2", "1.6", "1.3", "1", "0.8", "0.6", "0.5", "0.4", "0.3", "1/4", "1/5", "1/6", "1/8", "1/10", "1/13", "1/15", "1/20", "1/25", "1/30", "1/40", "1/50", "1/60", "1/80", "1/100", "1/125", "1/160", "1/200", "1/250", "1/320", "1/400", "1/500", "1/640","1/800", "1/1000", "1/1250", "1/1600","1/2000","1/2500","1/3200","1/4000", "1/5000", "1/6400", "1/8000", "1/10000", "1/12500", "1/16000", "1/20000", "1/25000", "1/32000", "1/40000", "1/50000", "1/64000","1/80000", "1/100k"};
+const char* tv_override[]={
+#if defined(CAM_HAS_EXTENDED_TV_LENGTH) && (CAM_HAS_EXTENDED_TV_LENGTH==1)
+    // add very long time exposures as approximately powers of 2, adding 15 exposures
+    "2048","1625","1290","1024","812","645","512","406","322","256","203","161","128","101","80",
+#endif
+    "64","50.8", "40.3", "32", "25.4","20","16", "12.7", "10","8", "6.3","5","4","3.2", "2.5","2", "1.6", "1.3", "1", "0.8", "0.6", "0.5", "0.4", "0.3", "1/4", "1/5", "1/6", "1/8", "1/10", "1/13", "1/15", "1/20", "1/25", "1/30", "1/40", "1/50", "1/60", "1/80", "1/100", "1/125", "1/160", "1/200", "1/250", "1/320", "1/400", "1/500", "1/640","1/800", "1/1000", "1/1250", "1/1600","1/2000","1/2500","1/3200","1/4000", "1/5000", "1/6400", "1/8000", "1/10000", "1/12500", "1/16000", "1/20000", "1/25000", "1/32000", "1/40000", "1/50000", "1/64000","1/80000", "1/100k"};
+const int tv_override_amount = sizeof(tv_override)/sizeof(tv_override[0]);
+
+#if defined(CAM_HAS_EXTENDED_TV_LENGTH) && (CAM_HAS_EXTENDED_TV_LENGTH==1)
+const int tv_override_zero_shift = 18+15;
+#else
+const int tv_override_zero_shift = 18;
+#endif
 static const char * expo_type[] = { "+/-", "-","+"};
 
 static PHOTO_PARAM photo_param_put_off;
@@ -110,7 +122,7 @@
 const ShutterSpeed *shooting_get_tv_line()
 {
     short tvv;
-    long i;
+    unsigned i;
     _GetPropertyCase(PROPCASE_USER_TV, &tvv, sizeof(tvv));
     for (i=0;i<SS_SIZE;i++){
 	   if (shutter_speeds_table[i].prop_id == tvv)
@@ -123,7 +135,7 @@
 {
 #if CAM_HAS_USER_TV_MODES
 if ((mode_get()&MODE_MASK) != MODE_PLAY){
-    long i;
+    unsigned i;
 //    if ((v<SSID_MIN) || (v>SSID_MAX))
 //	return;
  for (i=0;i<SS_SIZE;i++){
@@ -162,7 +174,7 @@
 int shooting_get_iso_mode()
 {
     short isov;
-    long i;
+    unsigned i;
     _GetPropertyCase(PROPCASE_ISO_MODE, &isov, sizeof(isov));
     for (i=0;i<ISO_SIZE;i++){
 			if (iso_table[i].prop_id == isov)
@@ -564,7 +576,7 @@
 
 void shooting_set_tv96(short v, short is_now)
 {
- long i;
+    unsigned i;
 //    if ((v<SSID_MIN) || (v>SSID_MAX))
 //	return;
 if ((mode_get()&MODE_MASK) != MODE_PLAY){
@@ -820,7 +832,7 @@
 
 void shooting_set_iso_mode(int v)
 {
- long i;
+ unsigned i;
  for (i=0;i<ISO_SIZE;i++){
 	if (iso_table[i].id == v){
 	    short vv = iso_table[i].prop_id;
@@ -980,7 +992,7 @@
 
 void shooting_video_bitrate_change(int v){
  int m[]={1,2,3,4,5,6,7,8,10,12};  // m[v]/4 = bitrate*1x
- if (v>=(sizeof(m)/sizeof(m[0]))) v=(sizeof(m)/sizeof(m[0]))-1;
+ if ((unsigned)v>=(sizeof(m)/sizeof(m[0]))) v=(sizeof(m)/sizeof(m[0]))-1;
 #if CAM_CHDK_HAS_EXT_VIDEO_MENU
  change_video_tables(m[v],4);
 #endif
@@ -1022,7 +1034,7 @@
 
 short shooting_get_av96_override_value()
 {
-  if (conf.av_override_value<=AS_SIZE)	return (short) aperture_sizes_table[conf.av_override_value-1].prop_id;
+  if ((unsigned)conf.av_override_value<=AS_SIZE)	return (short) aperture_sizes_table[conf.av_override_value-1].prop_id;
   else return (short) (AV96_MAX+32*(conf.av_override_value-AS_SIZE));
 }
 
@@ -1220,7 +1232,8 @@
    else if (((conf.tv_enum_type) || (conf.tv_override_value)) && (conf.tv_override_koef) && !(conf.override_disable==1))
    { 
    if (conf.tv_enum_type) 
-     shooting_set_tv96_direct(32*(conf.tv_override_value-18),SET_NOW);
+//     shooting_set_tv96_direct(32*(conf.tv_override_value-18),SET_NOW);
+     shooting_set_tv96_direct(32*(conf.tv_override_value-(tv_override_zero_shift)),SET_NOW);
    else   
     shooting_set_tv96_direct(shooting_get_tv96_from_shutter_speed(shooting_get_shutter_speed_override_value()), SET_NOW); 
    }
Index: platform/generic/makefile.inc.new
===================================================================
--- platform/generic/makefile.inc.new	(Revision 0)
+++ platform/generic/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
